# CommandCode class defines all the code
# on server command
class CommandCode:

	SAVE_CONFIG = 0
	SHOW_CONFIG = 1

	SET_OPTION  = 2
	
	QUEUE_INFO  = 3
	
	SHUT_DOWN   = 4

	SETUP       = 5
	POLL        = 6
	EMAIL       = 7
	QUIT_POLL   = 8
	HELLO_MSG   = 9
	SETUP_USER  = 10
	REQUEST     = 11
	CHECK		= 12
	FETCH_RESULT  = 13
	QUIT		= 14
	
	names = {'SAVE_CONFIG' : 0, 'SHOW_CONFIG' : 1,
			 'SET_OPTION' : 2, 'QUEUE_INFO' : 3,
			 'SHUT_DOWN' : 4, 'SETUP' : 5,
			 'POLL' : 6, 'EMAIL' : 7, 'QUIT_POLL' : 8,
			 'HELLO_MSG' : 9, 'SETUP_USER' : 10,
			 'CHECK' : 12, 
			 'FETCH_RESULT' : 13, 'QUIT' : 14 }

	codeToName = { 1:'SHOW_CONFIG',
				   3:'QUEUE_INFO',
				   6:'POLL',
				   9:'HELLO_MSG',
				   7:'EMAIL',
				   10:'SETUP_USER',
				   12:'CHECK',
				   14:'QUIT'
				 }

	numArgs = {'SAVE_CONFIG' : 0, 'SHOW_CONFIG' : 0,
			   'SET_OPTION' : 2, 'QUEUE_INFO' : 1,
			   'SHUT_DOWN' : 0, 'FETCH_RESULT' : 1,
			   'QUIT' :0
			   }

class RequestCode:

   	COMMAND = 0
	EVENTS  = 1
	AUTH    = 2
	
	codeToName = { 0:'Command', 1:'Event',
				   2:'Auth' }
	
class ResultCode:

   	# if requestResult is 1, then following option
	# determines how the result is treated
	# HOLD_RESULT -- The result is put into the queue
	# SAVE_RESULT -- The result is saved into a file
	# RESULT_BACK -- The result is immediately sent back to client
	HOLD_RESULT = 0
	SAVE_RESULT = 1
	RESULT_BACK = 2
	
class Operation:

	EXECUTE = 0
	SEND    = 1
	RECEIVE = 2

	# These modes are used by restricted execution
	# when it is on
	RE_SYNTAX = 1
	CMD_ID    = 2
	
	codeToName = {
		0:"EXECUTE_EVENT",
		1:"SEND_EVENT",
		2:"RECEIVE_EVENT"
		}
