import socket
from pickle import *
from string import *
from Config import *

class Connection:

	port = None
	connType = None

	sock = None
	
	# confDict should contain all the possible configuration
	# variables
	def setup(self):

		self.port = GlobalConfig.port
		self.connType = GlobalConfig.connection
		self.sock = socket.socket(self.connType, socket.SOCK_STREAM)

# Send a request, send a fixed len of characters to represent the
# serialize object length
def getRequest(conn):
   	s_len = conn.recv(16)
	length = atoi(s_len)
	msg = ''
	
	while len(msg) < length:
		chunk = conn.recv(length-len(msg))
		if not chunk:
			raise RunTimeError, "socket connection broken"
		msg = msg + chunk

	request = loads(msg)
	return request

# Serialize the obj, then sends the text representation over the
# socket
def sendRequest(conn, obj):
	s = dumps(obj)
	length = "%016i" % len(s)
	conn.send(length)
	conn.send(s)

# Given a result object and a socket object, and measure the
# connection ID
# return 1 if the connID (the integral port number) equals
# the result's connID
# connIDTuple is a tuple and expected to have one element -
# the reason is because this function is used with
# TaskQueue.matchFunc that the *args is passed on as a
# tuple object
def matchResult(result, connIDTuple):

	# print 'result.connID ' + `result.connID`
	# print 'conn ID ' + `conn[0].fileno()`
	
	return result.connID == connIDTuple[0]
