from os.path import *
from LogLevel import *
from Config import *
import sys, threading

class Logging:

	on = 0
	level = 0
	name = None
	buffer = None
	limit = 0

	# Conditional variable for stopping multiple threads
	# accessing to the same log at the same time
	cv = None
	logLock = None
	
	def setLevel(self, levelName):
		if LogLevel.__dict__.has_key(levelName):
			self.level = LogLevel.__dict__[levelName]
		
	def __init__(self):
		self.name = GlobalConfig.logfile
		self.level = GlobalConfig.logLevel
		self.on = GlobalConfig.logStatus
		self.buffer = ''
		self.logLock = threading.Lock()
		self.cv = threading.Condition(self.logLock)
		
	def turnOn(self):
		self.on = 1

	def turnOff(self):
		if self.on:
			self.update()
			self.buffer = ''
		self.on = 0

	# If the loglevel is valid, then check the buffer
	# over the limit. If over the limit update the logfile
	def write(self, message, msgLogLevel):

		# If xmlOutput is requst then we format the
		# log message
		if GlobalConfig.xmlOutput:
			xmlLogMsg = formXMLLogMessage(msgLogLevel, message)
		else:
			xmlLogMsg = message
			
		if msgLogLevel <= self.level and self.on:
			if len(xmlLogMsg) + len(self.buffer) >= self.limit:
				self.update()
				self.buffer = xmlLogMsg
			else:
				self.buffer = self.buffer + xmlLogMsg

	def update(self):
		self.cv.acquire()
		
		if self.name == 'stderr':
	   		self.log = sys.stderr
			sys.stderr.write(self.buffer)
			sys.stderr.flush()

		elif self.name == 'stdout':
			self.log = sys.stdout
			sys.stdout.write(self.buffer)
			sys.stdout.flush()

	   	else:
	   		self.log = open(self.name, 'a')
			self.log.write(self.buffer)	
			self.log.flush()
			self.log.close()
		self.log = None

		self.cv.release()
		
	def status(self):
		print 'Log filename: ' + self.name
		print 'Log level: ' + `self.level`
		if self.on:
			print 'Log status on'
		else:
			print 'Log status off'
		

