from AllCode import *

# Either events or daemon commmand
class Request:

	type = None

	cmdObj = None

	requestResult = None
	resultAction = None

	# Each request has to keep the fileno (returns by
	# the socket.fileno())
	connID = None
	
	# ID - this is useful when need to map the result
	# to which request
	id = None
	
	def __init__(self, type, cmdObj, request,
				 action):
		self.type = type
		self.cmdObj = cmdObj
		self.requestResult = request
		self.resultAction = action
		self.id = cmdObj.id

	# This function is to make sure certain rules
	# does apply inside a request before sending
	# it.
	def check(self):
		
		# If this is command type, forced to set requestAction
		if self.type == RequestCode.COMMAND:
			self.setResultAction(1, ResultCode.RESULT_BACK)

		return self.cmdObj.check()

	def setResultAction(self, request, action):
		self.requestResult = request
		self.resultAction = action
		
	def setConnID(self, id):
		self.connID = id
		if self.isEvent():
			self.cmdObj.setConnID(id)

	def waitForResult(self):
		if (self.requestResult and
			self.resultAction == 2):
			return 1
		else:
			return 0
		
	def status(self):
		print RequestCode.codeToName[self.type]
		print "request result" + `self.requestResult`
		print "result action" + `self.resultAction`

		if self.connID:
			print "Connection ID: " + `self.connID` + '\n'
		else:
			print "Lost connection ID\n"

	def isCommand(self):
		if self.type == RequestCode.COMMAND:
			return 1
		return 0

	def isEvent(self):
		return self.type == RequestCode.EVENTS

	def getEvent(self):
		return self.cmdObj

	def getCommand(self):
		return self.getEvent()
	
	def askResultBack(self):
		if self.requestResult:
			return 1
		return 0

	def isRequest(self):
		return 1

	def getCommandCode(self):
		return self.cmdObj.getCommandCode()
