import os
import base64
from StringIO import *
from zlib import *
from os.path import *
from stat import *
from shutil import *
from errno import *
from time import *
from string import *

class SourceData:

	# file path and name
	path = None
	name = None

	# flag to tell whether the data is compressed
	compressed = None

	# Actual data
	data = None

	# Blocks - breaks the data into blocks
	lineSize = 200
	inBlock = None

	# Presumed all the checkings have been
	# done prior to the constructor call
	def __init__(self, file, startDir):
		f = open(file, 'r')
		size = os.stat(file)[ST_SIZE]
		self.data = f.read(size+1)
		f.close()
		self.compressed = 0
		self.inBlock = 0
		path, self.name = os.path.split(file)

		self.path = replace(path, startDir, '')

	# Given a data, encode it.
	# returns a list of encoded strings
	def packBlocks(self):

		if not self.inBlock and self.data:
			bList = []
			buffer = StringIO()
			input = base64.encodestring(self.data)

			# Now the self.data contains a list of lines
			self.data = StringIO(input).readlines()
			self.inBlock = 1

	# Concatenate the chunks into one string, decode
	def unpackBlocks(self):

		if self.inBlock and self.data:
			buffer = ''
			for x in self.data:
				buffer = buffer + x

			self.data = base64.decodestring(buffer)
			self.inBlock = 0

	def inBlocks(self):
		return self.inBlock

	def clearData(self):
		self.data = None
		self.compressed = 0
		self.inBlock = 0
		
	# Must always compress before packBlocks
	def compress(self):

		if self.inBlocks():
			self.unpackBlocks()

		if self.data:
			self.data = compress(self.data)
			self.compressed = 1

	def isCompressed(self):

		return self.compressed

	def uncompress(self):

		if self.inBlocks():
			self.unpackBlocks()

		if self.data:
			self.data = decompress(self.data)
			self.compressed = 0

	# Given a target path name and write the file
	# into target path / self.path
	# return (0, msg) if file is dumped successfully
	# return (1, msg) if error
	def dumpFile(self, targetPath):

		combinePath = self.path
		if targetPath == None:
			targetPath = ''

		# Append the file path into the target path
		# create dirs if not exist
		combinePath = abspath(targetPath + self.path)

		if not isdir(combinePath):
		   	try:
			   	os.makedirs(combinePath)
			except OSError, (errno, strerror):
		   		msg = ('Trying to make directories: ' +
			   		   combinePath + '\n')
			   	return (1, msg + `os.strerror(errno)` + '\n')

		if not os.access(combinePath, os.W_OK):
			return (1, 'No write permission: ' + combinePath)

		# If file already exists, back up the old file
		combineFilePath = os.path.join(combinePath, self.name)
		msg = ''

		if (isfile(combineFilePath) and
		    not os.access(combineFilePath, os.W_OK)):
			msg = ('No write permission on file: ' + combineFilePath)
			combineFilePath = combineFilePath + '.actim.' + `int(time())-5`
			msg = msg + ('\nOverwrite with filename: ' + `combineFilePath`)
		elif isdir(combineFilePath):
			msg = ('A directory is already existed: ' + combineFilePath)
			combineFilePath = combineFilePath + '.actim.' + `int(time())-5`
			msg = msg + ('\nOverwrite with filename: ' + `combineFilePath` + '\n')

		if isfile(combineFilePath):

			saveFileName = combineFilePath + '.actim.' + `int(time())-5`
			msg = ('Warning: Replace existing file. Save old file: ' +
				   saveFileName + '\n')
			copyfile(combineFilePath, saveFileName)

		f = open(combineFilePath, 'w')
		f.write(self.data)
		f.close()
		msg = msg + combineFilePath + ' is written successfully\n'
		return (0, msg)
							
