import smtplib
from Config import *
from LogLevel import *

def setupSMTP():

	if not 'SMTP' in TransmitMedia.mediaList:
		TransmitMedia.smtp = TransmitSMTP()
		TransmitMedia.mediaList.append('SMTP')

class TransmitMedia:

	mediaList = []
	smtp = None

class TransmitSMTP:

	def __init__(self):

		self.server = GlobalConfig.SMTP_server
		self.port   = GlobalConfig.SMTP_port
		self.subject = GlobalConfig.mailSubject
		self.log    = GlobalConfig.log
		
	def transmit(self, fromAddr, to, data):
		
		self.media = smtplib.SMTP(self.server, self.port)

		# Construct message
		msg =  ("From: %s\r\nSubject: %s\r\nTo: %s\r\n\r\n" %
			   	(fromAddr, self.subject, to))
		msg = msg + data
		
		self.log.write("Sending a message from %s to %s...\n" %
					   (fromAddr, to), LogLevel.COMMS_EVENT)

		self.media.sendmail(fromAddr, to, msg)
		self.media.quit()


		
		
