#!/usr/local/bin/python

import sys, time, popen2, os
from os.path import *
from testTools import *
from Config import *
from ParseResult import *
from MDC import *

if mdc_isLose():
	initConfig([mapPath("~/.actimrc")], None, 0)
else:
	initConfig([expanduser("~/.actimrc")], None, 0)

emailAddress = GlobalConfig.emailAddress

numPassed = 0
numFailed = 0

backUpActimrc()
backUpActimdrc()

defaultOpts = {
	"eKey":"testing"
	}

securityOpts = {
	"allowFileSend":0,
	"allowFileReceive":0,
	"allowExecution":1,
	"serviceTimeLimit":0
	}

modifyActimRC(mapPath("~/.actimdrc"), None, securityOpts)
modifyActimRC(mapPath("~/.actimrc"), defaultOpts, None)

if emailAddress != None:


	startActimdBg()

	if mdc_isLose():
		test = ["*********** Test event command ls -l /tmp ***********\n",
			"python ..\\..\\actim -E -e \"dir C:\\Temp\" -d " + emailAddress + " -R", 
			"dir C:\\Temp", None, None]
	else:
		test = ["*********** Test event command ls -l /tmp ***********\n",
			"python ../../actim -E -e \"ls -l /tmp\" -d " + emailAddress + " -R", 
			"ls -l /tmp", None, None]

	result = simpleRunActim(test[0], test[1], test[2], test[3], test[4])

	if result == 0:
		numPassed = numPassed + 1
	else:
		numFailed = numFailed + 1
	
	stopServer()

# -------------------------------------------------------------------------------

	test = ["******* Test event invalid command 'foo bar' *******\n",
		    "python ../../actim -E -e \"foo bar\" -d " + emailAddress + " -R",
			"foo bar"]
			
	startActimdBg()

	sys.stdout.write(test[0])

	if mdc_isLose():
		test[1] = "python ../../actim -E -e \"foo bar\" -d %s -R" % emailAddress
		
	stdoutMsg, stderrMsg, rtCode = mdc_popen(test[1])

	if mdc_isLose() and len(stdoutMsg):
		rtCode = getEventExecuteReturnCode(None, None, stdoutMsg)
	
	if rtCode == 0:
		sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)
		sys.stdout.write(">>>>>>>> Fail: expect non zero return status <<<<<<<\n")
		numFailed = numFailed + 1
	
	else:
		sys.stdout.write(">>>>>>>> Pass: non-zero status return: " + `rtCode` +
						 " <<<<<<<\n")
		numPassed = numPassed + 1

	stopServer()

else:
	sys.stdout.write("Email address doesn't setup correctly\n")


restoreActimdrc()
restoreActimrc()

report('test_emailCommands', numPassed, numFailed, None)
report('test_emailCommands', numPassed, numFailed)

