#!/usr/local/bin/python

import sys, popen2, os
from os.path import *
from testTools import *
from Config import *
from time import *
from MDC import *

numPassed = 0
numFailed = 0

if mdc_isLose():
	initConfig([mapPath("~/.actimrc")], None, 0)
else:
	initConfig([expanduser("~/.actimrc")], None, 0)
	
emailAddress = GlobalConfig.emailAddress

# security option
securityOptDict = {
	"allowExecution":0,
	"allowFileSend":1,
	"allowFileReceive":1,
	"serviceTimeLimit":0
	}

defaultOpt = {
	"eKey":"testing"
	}

backUpActimdrc()
backUpActimrc()

# Change our desire configuration
modifyActimRC(mapPath("~/.actimrc"), defaultOpt, None)
modifyActimRC(mapPath("~/.actimdrc"), None, securityOptDict)

# Start actimd
startActimdBg()
sleep(3)

# --------------------------------------------------------------------
# Try to send a non-exist file
nonExistFile = '/tmp/agvjdbe'
test = ["*********** Send a non-existence file *************\n",
		"python ../../actim -E -f %s -p -d %s -R" % (nonExistFile, emailAddress)]

if mdc_isLose():
	test[1] = "python ..\\..\\actim -E -f \"C:\\Temp\\ajbhjfh\" -p -t \"C:\\Temp\" -d %s -R" % emailAddress
	
sys.stdout.write(test[0])
stdoutMsg, stderrMsg, result = mdc_popen(test[1])

if mdc_isLose() and len(stdoutMsg):
	result = getErrorExitCode(None, None, stdoutMsg)
	
if result == 9:
	sys.stdout.write(">>>>>> Passed <<<<<<")
	numPassed = numPassed + 1
else:
	sys.stdout.write(">>>>>> Failed <<<<<<")
	sys.stdout.writelines(stdoutMsg)
	sys.stdout.writelines(stderrMsg)
	numFailed = numFailed + 1

# --------------------------------------------------------------------
# Try to retrieve a non-existence file

test = ["*********** Retrieve a non-existence file *************\n",
		"python ../../actim -E -f %s -g -d %s -R" % (nonExistFile, emailAddress)]

if mdc_isLose():
	test[1] = "python ..\\..\\actim -E -f \"C:\\Temp\\ajbhjfh\" -g -t \"C:\\Temp\" -d %s -R" % emailAddress
	
sys.stdout.write(test[0])
stdoutMsg, stderrMsg, result = mdc_popen(test[1])

if mdc_isLose() and len(stdoutMsg):
	result = getEventFileReceiveReturnCode(None, None, stdoutMsg)
	
if result == 12:
	sys.stdout.write(">>>>>> Passed <<<<<<")
	numPassed = numPassed + 1
else:
	sys.stdout.write(">>>>>> Failed <<<<<<")
	sys.stdout.writelines(stdoutMsg)
	sys.stdout.writelines(stderrMsg)
	numFailed = numFailed + 1

# -------------------------------------------------------------------
# Test sending an file to own's address and finally compare the content
# on both files

if not mdc_isLose():
	dumpfile = '/tmp/testDump/testDump'
	target = '/tmp'
	targetFile = '/tmp/testDump.actim.*'
	os.system("rm -fr /tmp/testDump*")
	os.system("mkdir /tmp/testDump")

	test = ["*********** Test sending file event *****************\n",
			"python ../../actim -E -f " + dumpfile + " -p -t " + target + " -d " + emailAddress + " -R",
			None, dumpfile, targetFile]
	size = 2046

	createRandomFile(dumpfile, size)

	result = simpleRunActim(test[0], test[1], test[2], test[3], test[4])

	if result == 0:
		numPassed = numPassed + 1
	else:
		numFailed = numFailed + 1
		
	os.system("rm -fr /tmp/testDump*")

# ------------------------------------------------------------------
# Unset the compress option

if not mdc_isLose():
	clientOpt = {
		"compressFiles":0
		}
	modifyActimRC("~/.actimrc", clientOpt, None)

	dumpfile = '/tmp/testDump'
	targetFile = '/tmp/testDump.actim.*'
	os.system("rm -fr /tmp/testDump*")

	test = ["*********** Test retrieving file event *****************\n",
			"python ../../actim -E -f " + dumpfile + " -g -d " + emailAddress + " -R",
			None, dumpfile, targetFile]
	size = 100000

	createRandomFile(dumpfile, size)

	result = simpleRunActim(test[0], test[1], test[2], test[3], test[4])

	if result == 0:
		numPassed = numPassed + 1
	else:
		numFailed = numFailed + 1
		
	os.system("rm -f /tmp/testDump*")

stopServer()
restoreActimdrc()
restoreActimrc()

report('test_emailEvents', numPassed, numFailed, None)
report('test_emailEvents', numPassed, numFailed)

