#!/usr/local/bin/python

import sys, popen2, os
from os.path import *
from testTools import *
from Config import *
from time import *

numPassed = 0
numFailed = 0

if mdc_isLose():
	initConfig([mapPath("~/.actimrc")], None, 0)
else:
	initConfig([expanduser("~/.actimrc")], None, 0)
	
emailAccount = GlobalConfig.emailAccount
emailPassword = GlobalConfig.emailPassword

# fourth and fifth are the one setting to rc file
# sixth and seventh are the one in the argument. Hence the
# command must contain %s
# final arg is - do we test poll command with polling already running
testList = [
	("*********** Test poll email command  *****************\n",
	 "python ../../actim -C POLL EMAIL SETUP_USER",
	 0, None, None, 0),

	("*********** Test poll email command *******************\n" +
	 "*********** with incorrect password *******************\n",
	 "python ../../actim -C POLL EMAIL SETUP_USER",
	 1, 'hello', 'hello', 0),

	("*********** Correct login with account ******************\n" +
 	 "*********** name and password input    ******************\n",
	 "python ../../actim -C POLL EMAIL SETUP_USER \"%s\" \"%s\"" %
	 (emailAccount, emailPassword),
	 0, 'bunny', 'bee', 0),

	("*********** Correct login with account ******************\n" +
	 "*********** name but wrong password input ******************\n",
	 "python ../../actim -C POLL EMAIL SETUP_USER \"%s\" \"%s\"" %
	 (emailAccount, 'hello'),
	 1, None, None, 0),

	("*********** Correct login with account ******************\n" +
	 "*********** name only    ******************\n",
	 "python ../../actim -C POLL EMAIL SETUP_USER \"%s\"" %
	 emailAccount,
	 1, "sugar", "babe", 0),

	("********* Incorrect POLL EMAIL ERROR command ***********\n",
	 "python ../../actim -C POLL EMAIL ERROR",
	 19, None, None, 0),
	
	("********* Incorrect POLL command ***********\n",
	 "python ../../actim -C POLL",
	 19, None, None, 0),
	
	("********* Incorrect POLL EMAIL ERROR A B C command ***********\n",
	 "python ../../actim -C POLL EMAIL ERROR A B C",
	 19, None, None, 0),
	
	("********* Incorrect POLL HTTP SETUP_USER command ***********\n",
	 "python ../../actim -C POLL HTTP SETUP_USER",
	 19, None, None, 0),

	("********* starts POLL EMAIL SETUP_USER command ***********\n" +
	 "**** launch POLL EMAIL CHECK <user> <password> command *****\n" +
	 "********* Expects the test passed              ***********\n",
	 "python ../../actim -C POLL EMAIL SETUP_USER \"%s\" \"%s\"" %
	 (emailAccount, emailPassword),
	 0, None, None, 1),

	("********* starts POLL EMAIL SETUP_USER command ***********\n" +
	 "********* launch POLL EMAIL CHECK      command ***********\n" +
	 "********* Expects the test passed              ***********\n",
	 "python ../../actim -C POLL EMAIL CHECK",
	 0, None, None, 1),

	("***** starts POLL EMAIL SETUP_USER command with correct password *****\n" +
	 "***** launch POLL EMAIL CHECK      command with incorrect password ***\n" +
	 "***** Expects the test failed              ***********\n",
	 "python ../../actim -C POLL EMAIL CHECK hello world",
	 1, None, None, 1),

	("********* launch POLL EMAIL CHECK command only ***********\n" +
	 "********* Expect to fail                       ***********\n",
	 "python ../../actim -C POLL EMAIL CHECK",
	 1, None, None, 0)
	
	]

for test in testList:
	backUpActimrc()
	startActimdBg()
	sleep(3)

	sys.stdout.write(test[0])

	defaultOpt = {
		'eKey':'testing'
		}

	modifyActimRC(mapPath("~/.actimrc"), defaultOpt, None)

	# See whether need to have a successfull polling first
	if (test[5]):

		stdoutMsg, stderrMsg, initStart = mdc_popen(
			"python ../../actim -C POLL EMAIL SETUP_USER")

		if mdc_isLose() and len(stdoutMsg):
			initStart, a, b = parsePollCommandXMLResult(None, None, stdoutMsg)

		if initStart != 0:
			numFailed = numFailed + 1
			sys.stdout.write(">>>>>> Fail: Pre-start fail <<<<<<<<\n")
			sys.stdout.writelines(stdoutMsg)
			sys.stdout.writelines(stderrMsg)
			stopServer()
			restoreActimrc()
			continue

	if (test[3] != None or test[4] != None):
	   	if test[3] != None:
		   	defaultOpt['emailAccount'] = test[3]
		if test[4] != None:
	   		defaultOpt['emailPassword'] = test[4]

	modifyActimRC(mapPath("~/.actimrc"), defaultOpt, None)
	expectResult = test[2]

	sys.stdout.write(test[1])
	
	stdoutMsg, stderrMsg, result = mdc_popen(test[1])

	if mdc_isLose() and len(stdoutMsg):
		if expectResult == 0 or expectResult == 1:
		   	result, a, b = parsePollCommandXMLResult(None, None, stdoutMsg)
		elif expectResult == 19:
			result = getErrorExitCode(None, None, stdoutMsg)
		
	if result == expectResult:
   		numPassed = numPassed + 1
   		sys.stdout.write(">>>>>> Pass <<<<<<\n")
		sys.stdout.writelines(stdoutMsg)
   	else:
   		numFailed = numFailed + 1
   		sys.stdout.write(">>>>>> Fail <<<<<<<\n")
   		sys.stdout.writelines(stdoutMsg)
   		sys.stdout.writelines(stderrMsg)
	
	stopServer() 
	restoreActimrc()
	
report('test_pollEmailCmd', numPassed, numFailed, None)
report('test_pollEmailCmd', numPassed, numFailed)

