#!/usr/local/bin/python

import sys, time, popen2, os
from os.path import *
from testTools import *
from Config import *
from ParseResult import *
from MDC import *

if mdc_isLose():
	initConfig([mapPath("~/.actimrc")], None, 0)
else:
	initConfig([expanduser("~/.actimrc")], None, 0)
emailAddress = GlobalConfig.emailAddress

numPassed = 0
numFailed = 0

backUpActimrc()
backUpActimdrc()

defaultOpts = {
	"eKey":"testing",
	"logStatus":0
	}

modifyActimRC(mapPath("~/.actimrc"), defaultOpts, None)

# ----------------------------------------------------------------------

if emailAddress != None:

	securityOpts = {

	"allowFileSend":0,
	"allowFileReceive":0,
	"allowExecution":0
	}

	modifyActimRC(mapPath("~/.actimdrc"), None, securityOpts)

	startActimdBg()

	test = [("*********** Test event command ls -l /tmp ***********\n" +
			 "*********** Without permission from actimd **********\n"),
			"python ../../actim -E -e 'ls -l /tmp' -d " + emailAddress + " -R", 
			"ls -l /tmp"]

	sys.stdout.write(test[0])

	if mdc_isLose():
		test[1] = "python ..\\..\\actim -E -e \"dir C:\\Temp\" -d %s -R" % emailAddress
	
	stdoutMsg, stderrMsg, rtCode = mdc_popen(test[1])

	if mdc_isLose() and len(stdoutMsg):
		rtCode = getEventExecuteReturnCode(None, None, stdoutMsg)

	if rtCode == 8:
		sys.stdout.write(">>>>>>> Pass: match expected return code <<<<<<<\n")
		numPassed = numPassed + 1
	else:
		sys.stdout.write(">>>>>>>> Fail: expect return code mismatch <<<<<<<\n")
		sys.stdout.write(">>>>>>>> Fail: expected %s actual %s <<<<<<<\n" % (8, rtCode))
		sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)

		numFailed = numFailed + 1
	
	stopServer()

# ----------------------------------------------------------------------

	securityOpts = {

	"allowFileSend":1,
	"allowFileReceive":1,
	"allowExecution":0
	}

	modifyActimRC("~/.actimdrc", None, securityOpts)

	startActimdBg()

	test = [("*********** Test invalid command 'foo bar' ***********\n" +
			 "*********** Without permission from actimd **********\n" +
			 "*********** With file send/receive permission *******\n"),
			"python ../../actim -E -e \"foo bar\" -d " + emailAddress + " -R", 
			"foo bar"]

	sys.stdout.write(test[0])

	if mdc_isLose():
		test[1] = "python ..\\..\\actim -E -e \"foo bar\" -d %s -R" % emailAddress
	
	stdoutMsg, stderrMsg, rtCode = mdc_popen(test[1])

	if mdc_isLose() and len(stdoutMsg):
		rtCode = getEventExecuteReturnCode(None, None, stdoutMsg)

	if rtCode == 8:
		sys.stdout.write(">>>>>>> Pass: match expected return code <<<<<<<\n")
		numPassed = numPassed + 1
	else:
		sys.stdout.write(">>>>>>>> Fail: expect return code mismatch <<<<<<<\n")
		sys.stdout.write(">>>>>>>> Fail: expected %s actual %s <<<<<<<\n" % (8, rtCode))
		sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)

		numFailed = numFailed + 1
	
	stopServer()


restoreActimdrc()
restoreActimrc()

report('test_allowCommand', numPassed, numFailed, None)
report('test_allowCommand', numPassed, numFailed)
