from MDC import *
from testTools import *
from Config import *
import os

numFailed = 0
numPassed = 0

if mdc_isLose():
	initConfig([mapPath("~/.actimrc")], None, 0)
else:
   	initConfig([expanduser("~/.actimrc")], None, 0)

emailAddress = GlobalConfig.emailAddress

# A dictionary of all the configuration in
# correct value format
daemonConfigList = {
				   }

clientConfigList = {
	'eKey': 'avoid hanging'
				   }

# Multiple configuration in a list and then
# each configuration is represented in a tuple
# The tuple contains 3 item, first - section,
# second - option name, third - option value
# the third last item is the test title
# the second last item in the list is the expected
# exit code
# the second last item is the actimd command going to run
# the last item is the Window command to run
testConfigs = [
				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 1),
				  ("SECURITY", 'allowExecution', 1),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution on *****\n" +
				   "******* But no rcmdl_xxxx option   *****\n" +
				   "******* Expect actimd start fail **********\n"),
				  13, None, None ],
				
				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 1),
				  ("SECURITY", 'allowExecution', 1),
				  ("SECURITY", 'rcmdl_', 'ls -l'),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution on *****\n" +
				   "******* Set rcmdl_ option   *****\n" +
				   "******* Expect actimd start fail **********\n"),
				  13, None, None ],

				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 0),
				  ("SECURITY", 'allowExecution', 1),
				  ("SECURITY", 'rcmdl_', 'ls -l'),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution off *****\n" +
				   "******* Set rcmdl_ option   *****\n" +
				   "******* Expect actim runs fine **********\n"),
				  0, "python ../../actim -E -e \"ls -l\" -d %s" %
				     emailAddress,
				  "python ..\\..\\actim -E -e \"dir /w\" -d %s" %
				  emailAddress ],
				
				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 0),
				  ("SECURITY", 'allowExecution', 1),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution off *****\n" +
				   "******* Run actim with -i option *****\n" +
				   "******* Expect actimd return error to actim *****\n"),
				  15, "python ../../actim -E -i test1 -d %s" %
				     emailAddress,
				  "python ..\\..\\actim -E -i test1 -d %s" %
				  emailAddress ],
				
				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 1),
				  ("SECURITY", 'allowExecution', 1),
				  ("SECURITY", 'rcmdl_test2', 'ls -l'),
				  ("SECURITY", 'rcmdl_test1', ']ls -l['),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution on *****\n" +
				   "******* Set rcmdl_test to invalid re *****\n" +
				   "******* Expect actimd start fail **********\n"),
				  14, None, None ],

				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 1),
				  ("SECURITY", 'allowExecution', 1),
				  ("SECURITY", 'rcmdl_test1', 'ls -l [\w/]*$'),
				  ("SECURITY", 'rcmdl_test2', 'pwd'),
				  ("SECURITY", 'rcmdl_test3', 'ps -ef'),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution on *****\n" +
				   "******* Set 3 restricted commands  *****\n" +
				   "******* Voliate restricted command *****\n" +
				   "******* Expect to return error *********\n"),
				  15, "python ../../actim -E -e \"ls -l /etc/passwd ; cat /etc/passwd\" -d %s" % emailAddress,
				  "python ..\\..\\actim -E -e \"dir /w C:\\Window\" -d %s" %
				  emailAddress ],

				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 1),
				  ("SECURITY", 'allowExecution', 1),
				  ("SECURITY", 'rcmdl_test1', 'ls -l [\w/]*$'),
				  ("SECURITY", 'rcmdl_test2', 'pwd'),
				  ("SECURITY", 'rcmdl_test3', 'ps -ef'),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution on *****\n" +
				   "******* Set 3 restricted commands  *****\n" +
				   "******* Voliate restricted command *****\n" +
				   "******* Expect to return error *********\n"),
				  15, "python ../../actim -E -e \"cat /etc/passwd ; ls -l /etc/passwd\" -d %s" % emailAddress,
				  "python ..\\..\\actim -E -e \"dir /w C:\\Window\" -d %s" %
				  emailAddress ],

				[ ("SECURITY", 'serviceTimeLimit', 0),
				  ("SECURITY", 'restrictedExecution', 1),
				  ("SECURITY", 'allowExecution', 1),
				  ("SECURITY", 'rcmdl_test1', 'dir [\w/]*$'),
				  ("SECURITY", 'rcmdl_test2', 'pwd'),
				  ("SECURITY", 'rcmdl_test3', 'ps -ef'),
				  ("SECURITY", 'rcmdl_test4', 'ls -l [\w/]*$'),
				  ("******* Set allowExecution on ***********\n" +
				   "******* Set restrictedExecution on *****\n" +
				   "******* Set 4 restricted commands  *****\n" +
				   "******* Run valid restricted command *****\n" +
				   "******* Expect to run fine *********\n"),
				  0, "python ../../actim -E -e \"ls -l /etc/passwd\" -d %s" %
				  emailAddress,
				  "python ..\\..\\actim -E -e \"dir /w\" -d %s" %
				  emailAddress
				  ]
				
			  ]

for config in testConfigs:

	eRtn   = config[-3]
	title  = config[-4]

	if mdc_isLose():
		actimCmd = config[-1]
	else:
		actimCmd = config[-2]
	
	# update to options list
	testConfigList = daemonConfigList.copy()
	securityList = {}

	sys.stdout.write(title)

	for optionPair in config[:-4]:
		if optionPair[0] == "SECURITY":
			securityList[optionPair[1]] = optionPair[2]
		elif optionPair[0] == None:
			testConfigList[optionPair[1]] = optionPair[2]

		sys.stdout.write("######### Set option: %s to value %s in section %s\n"
						 % (optionPair[1], optionPair[2], optionPair[0]))
		
	# Backup the ~/,actimdrc
	backUpActimrc()
	backUpActimdrc()
	
	removeRestrictedCommand(mapPath("~/.actimdrc"))
	modifyActimRC(mapPath("~/.actimrc"), clientConfigList, None)
	modifyActimRC(mapPath("~/.actimdrc"), testConfigList, securityList)

	if eRtn == 0 or eRtn == 15 or eRtn == 1:
		startActimdBg()
		stdoutMsg, stderrMsg, rtCode = mdc_popen(actimCmd)

		if mdc_isLose() and len(stdoutMsg):
			rtCode = getEventExecuteReturnCode(None, None, stdoutMsg)
			
		if rtCode == eRtn:
			sys.stdout.write(">>>>>> Server response seems fine <<<<<<<<<\n")
			sys.stdout.write(">>>>>> Passed <<<<<<<<\n")
			numPassed = numPassed + 1
		else:
			sys.stdout.writelines(stdoutMsg)
			sys.stdout.writelines(stderrMsg)
			sys.stdout.write(">>>>>> Fail: Server doesn't response <<<<<<<<<\n")
			numFailed = numFailed + 1

		stopServer()
	else:
		# Havent done the XML output in actimd
		if mdc_isLose():
			restoreActimdrc()
			restoreActimrc()
			continue
		
		stdoutMsg, stderrMsg, rtnCode = mdc_popen("python ../../actimd")
		if rtnCode != eRtn:
			sys.stdout.writelines(stdoutMsg)
			sys.stdout.writelines(stderrMsg)
			sys.stdout.write(">>>>>> Failed: return code doesn't match expected <<<<<<<<<\n")
			sys.stdout.write(">>>>>> Expected return code " + `eRtn` + ", actual " +
							 `rtnCode` + " <<<<<<<\n")
			numFailed = numFailed + 1
		else:
			sys.stdout.writelines(stderrMsg)
			sys.stdout.write(">>>>>> Passed <<<<<<<\n")
			numPassed = numPassed + 1

	restoreActimrc()
	restoreActimdrc()
	
report('test_daemonRestrictedCommand', numPassed, numFailed, None)
report('test_daemonRestrictedCommand', numPassed, numFailed)
