#!/usr/local/bin/python

import sys, popen2, os
from os.path import *
from testTools import *
from Config import *
from time import *
from MDC import *
from ParseResult import *

numPassed = 0
numFailed = 0

if mdc_isLose():
	initConfig([mapPath("~/.actimrc")], None, 0)
else:
	initConfig([expanduser("~/.actimrc")], None, 0)

emailAddress = GlobalConfig.emailAddress

defaultOpt = {
	"eKey":"testing",
	"targetPath":mapPath("/tmp")
	}

backUpActimdrc()
backUpActimrc()

# Change our desire configuration
modifyActimRC(mapPath("~/.actimrc"), defaultOpt, None)

# --------------------------------------------------------------------
# Try to retrieve a non-existence file

# security option
securityOptDict = {
	"allowExecution":0,
	"allowFileSend":1,
	"allowFileReceive":0,
	"serviceTimeLimit":0
	}

modifyActimRC(mapPath("~/.actimdrc"), None, securityOptDict)

nonExistFile = mapPath('/tmp/agvjdbe')
test = ["*********** Send a non-existence file *************\n" +
		"********** Without get file permission ************\n",
		"python ../../actim -E -f %s -g -d %s -R" % (nonExistFile, emailAddress)]

startActimdBg()

sys.stdout.write(test[0])

if mdc_isLose():
	test[1] = "python ..\\..\\actim -E -f %s -g -d %s -R" % (nonExistFile, emailAddress)
	
stdoutMsg, stderrMsg, result = mdc_popen(test[1])

if mdc_isLose() and len(stdoutMsg):
	result = getEventFileReceiveReturnCode(None, None, stdoutMsg)

if result == 10:
	numPassed = numPassed + 1
else:
	sys.stdout.write(">>>>>> Fail: return code mismatch <<<<<<<\n")
	sys.stdout.write(">>>>>> Fail: actual %s, expect %s <<<<<<<\n" % (result, 11))
	sys.stdout.writelines(stdoutMsg)
	sys.stdout.writelines(stderrMsg)
	numFailed = numFailed + 1

stopServer()
restoreActimdrc()

# -------------------------------------------------------------------
# Test sending an file to own's address and finally compare the content
# on both files

backUpActimdrc()

# security option
securityOptDict = {
	"allowExecution":0,
	"allowFileSend":0,
	"allowFileReceive":1,
	"serviceTimeLimit":0
	}

modifyActimRC(mapPath("~/.actimdrc"), None, securityOptDict)

dumpfile = mapPath('/tmp/testDump/testDump')
target = mapPath('/tmp')
targetFile = mapPath('/tmp/testDump.actim.*')
if mdc_isLose():
	os.system("del C:\\Temp\\testDump*")
	os.system("mkdir C:\\Temp\\testDump")
else:
	os.system("rm -fr /tmp/testDump*")
	os.system("mkdir /tmp/testDump")

test = ["*********** Test sending file event *****************\n" +
		"********* Without send file permission **************\n",
		"python ../../actim -E -f " + dumpfile + " -p -t " + target + " -d " + emailAddress + " -R"]
size = 2046

createRandomFile(dumpfile, size)

startActimdBg()

sys.stdout.write(test[0])

if mdc_isLose():
	test[1] = "python ..\\..\\actim -E -f %s -p -t %s -d %s" % (dumpfile, target, emailAddress)
	
stdoutMsg, stderrMsg, result = mdc_popen(test[1])

if mdc_isLose() and len(stdoutMsg):
	result = getEventFileSendReturnCode(None, None, stdoutMsg)

if result == 11:
	numPassed = numPassed + 1
else:
	sys.stdout.write(">>>>>> Fail: return code mismatch <<<<<<<\n")
	sys.stdout.write(">>>>>> Fail: actual %s, expect %s <<<<<<<\n" % (result, 11))
	sys.stdout.writelines(stdoutMsg)
	sys.stdout.writelines(stderrMsg)
	numFailed = numFailed + 1

if mdc_isLose():
	os.system("del /S C:\\Temp\\testDump*")
else:	
	os.system("rm -fr /tmp/testDump*")

stopServer()
restoreActimdrc()

report('test_fileEventsPermission', numPassed, numFailed, None)
report('test_fileEventsPermission', numPassed, numFailed)
