import os, stat
from MDC import *
from os.path import *
from testTools import *

# Windows doesn't support file permission
if mdc_isLose():
	sys.exit(0)

numPassed = 0
numFailed = 0

actimFile = expanduser('~/.actimrc')
actimdFile = expanduser('~/.actimdrc')

stat1 = os.stat(actimFile)
mode1 = stat1[stat.ST_MODE]
permission1 = stat.S_IMODE(mode1)

stat2 = os.stat(actimdFile)
mode2 = stat2[stat.ST_MODE]
permission2 = stat.S_IMODE(mode2)

# Save the code first

# First arg rc file location
# second arg rc file permission
# third arg actimd or actim, 1 - actimd, 0 - actim
# Fourth arg expect return code
testConfig = [
			   (actimFile, 0600, 0, 0),
			   (actimFile, 0700, 0, 0),
			   (actimFile, 0642, 0, 6),
			   (actimFile, 0606, 0, 6),
			   (actimFile, 0660, 0, 6),
			   (actimdFile, 0600, 1, 0),
			   (actimdFile, 0700, 1, 0),
			   (actimdFile, 0642, 1, 6),
			   (actimdFile, 0606, 1, 6),
			   (actimdFile, 0660, 1, 6),
			   ('/tmp/actimdrc1', 0604, 1, 0),
			   ('/tmp/actimdrc2', 0656, 1, 6),
			   ('/tmp/actimdrc3', 0400, 1, 1),
			   ('/tmp/actimdrc4', 0644, 1, 0),
			   ('/tmp/actimdrc5', 0401, 1, 1)
			 ]

for test in testConfig:

	sys.stdout.write("********** Test actimrc file permission **********\n")
	sys.stdout.write("********** Set it to mode %s ************\n" % oct(test[1]))

    # Set the mode
	if isfile(test[0]):

		# If test file is /tmp/actimdrc, then we should force it's not
		# belonging to me
		if test[0][:4] == '/tmp':
			if mdc_isMyFile(test[0]):
				sys.stdout.write(">>>>>> Fail: file %s needs to belong to someone else for the test <<<<<<<\n" % test[0])
				numFailed = numFailed + 1
				continue
		else:
			os.chmod(test[0], test[1])

	else:
		sys.stdout.write(">>>>>> Fail: file %s doesn't exist <<<<<<\n" % test[0])
		numFailed = numFailed + 1
		continue

	if not test[2]:
		stdoutMsg, stderrMsg, rtCode = mdc_popen("python ../../actim -s")
	else:
		if test[3]:
			stdoutMsg, stderrMsg, rtCode = mdc_popen("python ../../actimd -c %s"
													 % test[0])
		else:
			# Start actim properly with .actimrc file with
			# right permission
			startActimdBg(None, 'python ../../actimd -c %s &' % test[0])
			os.chmod(actimFile, 0600)
			stdoutMsg, stderrMsg, rtCode = mdc_popen("python ../../actim -C SHOW_CONFIG")
			stopServer()
			

	if rtCode == test[3]:

		sys.stdout.write(">>>>>>>> Pass: actual return code matches expected <<<<<\n")
		numPassed = numPassed + 1
	else:
		sys.stdout.write(">>>>>>>> Fail: actual return code doesn't match as expected <<<<\n")
		sys.stdout.write(">>>>>>>> Fail: expected: %s, actual: %s <<<<<<<\n" % (test[3], rtCode))
		os.system("ls -l %s" % test[0])
		sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)

  	   	numFailed = numFailed + 1
		
os.chmod(actimFile, permission1)
os.chmod(actimdFile, permission2)

report('test_rcfilePermission', numPassed, numFailed, None)
report('test_rcfilePermission', numPassed, numFailed)
