from MDC import *
from testTools import *
from ParseResult import *
import os, socket

numFailed = 0
numPassed = 0

# A dictionary of all the configuration in
# correct value format
clientConfigList = { 
					 'port': 17870,
					 'server': socket.gethostname(),
					 'requestRequest':1,
					 'resultAction':0,
					 'emailAddress':"abc@def.hij",
					 'emailPassword':"abc",
					 'emailAccount': "abcdefg",
					 'logStatus': 1,
					 'targetPath':mapPath("/tmp"),
					 'eKey':"avoid hanging",
					 'xmlOutput': 1
				   }

testConfigs = [ ('****** Test actim -c rcfile .... *********',
				 'python %s -c %s -C SHOW_CONFIG' %
				 (mapPath('../../actim'), mapPath('/tmp/testRCFile')), 0),

				('****** Test actim ..... -c file  *********',
				 'python %s -C SHOW_CONFIG -c %s' %
				 (mapPath('../../actim'), mapPath('/tmp/testRCFile')), 0)

			  ]

for test in testConfigs:

	title = test[0]
	command = test[1]
	expectedResult = test[2]

	backUpActimrc()

	# update to options list
	testConfigList = clientConfigList.copy()

	createActimRCFile(testConfigList, mapPath("/tmp/testRCFile"))

	startActimdBg()

	stdoutMsg, stderrMsg, returnCode = mdc_popen(command)

	returnCode, dict, errorMsg = parseShowConfigXMLResult(None, None, stdoutMsg)

	if returnCode == 0 and stdoutMsg[0] == "<?xml version=\"1.0\"?>\n":
	   	sys.stdout.write(">>>>>> Server response seems fine <<<<<<<<<\n")
		sys.stdout.write(">>>>>> Passed <<<<<<<<\n")
	   	numPassed = numPassed + 1
	else:
	   	sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)
		sys.stdout.write(">>>>>> Fail: Server doesn't response <<<<<<<<<\n")
	   	numFailed = numFailed + 1

	stopServer()
	restoreActimrc()

report('test_actimCommand', numPassed, numFailed, None)
report('test_actimCommand', numPassed, numFailed)

	
