from MDC import *
from testTools import *
from ParseResult import *
import os, socket

numFailed = 0
numPassed = 0

# A dictionary of all the configuration in
# correct value format
clientConfigList = { 
					 'port': 17870,
					 'server':socket.gethostname(),
					 'requestRequest':1,
					 'resultAction':0,
					 'emailAddress':"abc@def.hij",
					 'emailPassword':"abc",
					 'emailAccount': "abcdefg",
					 'logStatus': 1,
					 'targetPath':"/tmp",
					 'eKey':"avoid hanging",
					 'xmlOutput': 1
				   }


# Multiple configuration in a list and then
# each configuration is represented in a tuple
# the penultimate item is the test title
# the last item in the list is the expected
# exit code
testConfigs = [
				[ ('requestResult', "1"),
				  ('resultAction', "0"),
				  ("******* Set requestResult on ***********\n" +
				   "******* Set resultAction to HOLD_RESULT *****\n" +
				   "******* Test daemon command and make sure the result is back *****\n"),
				  0 ],
				
				[ ('requestResult', "1"),
				  ('resultAction', "1"),
				  ("******* Set requestResult on ***********\n" +
				   "******* Set resultAction to SAVE_RESULT *****\n" +
				   "******* Test daemon command and make sure the result is back *****\n"),
				  0 ]
			  ]

for config in testConfigs:

	eRtn   = config[-1]
	title  = config[-2]

	# update to options list
	testConfigList = clientConfigList.copy()

	sys.stdout.write(title)
	
	for optionPair in config[:-2]:
		option = optionPair[0]
		value  = optionPair[1]

		testConfigList[option] = value
	
		sys.stdout.write("######### Set option: " + option +
						 " to value: " + `value` + ' ########\n')	

	# Backup the ~/,actimdrc
	backUpActimrc()

	# Create ~/.actimdrc from a dictionary
	createActimRCFile(testConfigList)

	if eRtn == 0:
		startActimdBg()
		stdoutMsg, stderrMsg, rtCode = mdc_popen("%s -C QUEUE_INFO ALL" %
												 actimCmd())
		if mdc_isLose():
			rtCode, dict, error = parseQueueInfoXMLResult(None, None, stdoutMsg)

		if rtCode == 0:
			sys.stdout.write(">>>>>> Server response seems fine <<<<<<<<<\n")
			sys.stdout.write(">>>>>> Passed <<<<<<<<\n")
			numPassed = numPassed + 1
		else:
			sys.stdout.writelines(stdoutMsg)
			sys.stdout.writelines(stderrMsg)
			sys.stdout.write(">>>>>> Fail: Server doesn't response <<<<<<<<<\n")
			numFailed = numFailed + 1

		stopServer()
	else:
		stdoutMsg, stderrMsg, rtnCode = mdc_popen("%s -C QUEUE_INFO ALL" %
												  actimCmd())

		if mdc_isLose():
			rtnCode = getErrorExitCode(None, None, stdoutMsg)
			
		if rtnCode != eRtn:
			sys.stdout.write(">>>>>> Failed: return code doesn't match expected <<<<<<<<<\n")
			sys.stdout.write(">>>>>> Expected return code " + `eRtn` + ", actual " +
							 `rtnCode` + " <<<<<<<\n")
			numFailed = numFailed + 1
		else:
			sys.stdout.writelines(stderrMsg)
			sys.stdout.write(">>>>>> Passed <<<<<<<\n")
			numPassed = numPassed + 1

	restoreActimrc()

report('test_clientMultipleConfig', numPassed, numFailed, None)
report('test_clientMultipleConfig', numPassed, numFailed)
