#!/usr/local/bin/python

import sys, os, time
from testTools import *
from MDC import *
from ParseResult import *

numFailed = 0
numPassed = 0

startActimdBg()

testCmdList = [("*********** Test daemon command QUEUE_INFO ALL ***********\n",
				"python ../../actim -C QUEUE_INFO ALL", 1, None, None),

			   ("*********** Test daemon command SHOW_CONFIG **************\n",
				"python ../../actim -C SHOW_CONFIG", 2, None, None),

			   ("*********** Test daemon command SHOW_CONFIG -R **********\n",
				"python ../../actim -C SHOW_CONFIG -R", 2, None, None)]

wrongCmdList = [("****** Test daemon wrong command QUEUE_INFO  **********\n",
				"python ../../actim -C QUEUE_INFO", None, 17, None),

				("****** Test daemon wrong command QUEUE_INFO NONE **********\n",
				"python ../../actim -C QUEUE_INFO NONE", 1, 15, None),
				
				("******** Test daemon command SHOW_CONFIG ALL *********\n",
				"python ../../actim -C SHOW_CONFIG ALL", None, 17, None)]

for test in testCmdList:
 	sys.stdout.write(test[0])
	stdoutMsg, stderrMsg, result = mdc_popen(wrapActimCommand(test[1]))

	if mdc_isLose():
		if test[2] == 1:
			result, dict, error = parseQueueInfoXMLResult(None, None, stdoutMsg)
		elif test[2] == 2:
			result, dict, error = parseShowConfigXMLResult(None, None, stdoutMsg)
	if result == 0:
		numPassed = numPassed + 1
	else:
		sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)
		numFailed = numFailed + 1

for test in wrongCmdList:
	sys.stdout.write(test[0])
	stdoutMsg, stderrMsg, result = mdc_popen(wrapActimCommand(test[1]))

	if mdc_isLose():
		if test[2] == 1:
			result, dict, error = parseQueueInfoXMLResult(None, None, stdoutMsg)
		elif test[2] == None:
			result = getErrorExitCode(None, None, stdoutMsg)

	if result == test[3]:
		numPassed = numPassed + 1
	else:
		sys.stdout.writelines(stdoutMsg)
		sys.stdout.writelines(stderrMsg)
		numFailed = numFailed + 1

	sys.stdout.write("\n\n")

stopServer()

report('test_daemonCmds', numPassed, numFailed, None)
report('test_daemonCmds', numPassed, numFailed)

