import sys, os, string, time, re
from thread import *
from MDC import *
from ConfigParser import *
from os.path import *
from ParseResult import *

# A quick function to return the command in multiplatform
def actimCmd():
	return "python %s " % mapPath("../../actim")

def actimdCmd():
	return "python %s " % mapPath("../../actimd")

# filename is either ~/.actimdrc or ~/.actimrc
def mapRCFilename(filename):
	if sys.platform[:3] == 'win':
		rcFileName = mapPath(filename)
	else:
		rcFileName = filename

	return rcFileName

def wrapActimCommand(actimCommand):
    if sys.platform[:3] == 'win':
	# actimCommand = "sh -c '%s'" % actimCommand
		actimCommand = string.replace(actimCommand, '\\', '\\\\')
    return actimCommand

# Map the unix pathname to window pathname
def mapPath(unixPath):

	if sys.platform[:3] == 'win':
		winPath = normpath(unixPath)

   		if os.environ.has_key('ACTIM'):
	   		actimPath = os.environ['ACTIM']
		else:
		   	actimPath = 'C:\\ACTIM\\'

		# Map tmp to temp
		# .actimrc to $ACTIM/actim.ini
		# .actimdrc to $ACTIM/actimd.ini
		if winPath[1:4] == 'tmp':
			winPath = 'C:\\Temp' + winPath[4:]
		elif len(winPath) > 9 and winPath[-8:] == '.actimrc':
			winPath = actimPath + 'actim.ini'
		elif len(winPath) > 10 and winPath[-9:] == '.actimdrc':
			winPath = actimPath + 'actimd.ini'

		return winPath
	else:
		return unixPath
	
def startActimdBg(port=17870, cmd="python ../../actimd &"):

	if port == None:
		port = 17870
		
	if sys.platform[:3] == 'win':
	    os.system("start /min python ..\\..\\actimd")
	else:
		a, b, c = mdc_popen("netstat | grep %s" % port)
		while (c == 0):
			a, b, c = mdc_popen("netstat | grep %s" % port)
		os.system(cmd)

	time.sleep(3)

def showResults():
	if len(sys.argv) > 0:
		if "-s" in sys.argv:
			return 1

	return 0

def printStdMessages(fp, stdoutMsg, stderrMsg):
	show = showResults()

	if show:
		fp.write("--->standard output\n")
		fp.writelines(stdoutMsg)
		fp.write("<--standard output\n")
		fp.write("--->standard error\n")
		fp.writelines(stderrMsg)
		fp.write("<--standard error\n")

def printMessage(fp, msg):
	show = showResults()

	if show:
		fp.write(msg)
	
def openResultFile():
	if len(sys.argv) > 0:
		if "-o" in sys.argv:
			index =  sys.argv.index("-o")
			args = sys.argv[index:index+2]
			if len(args) == 2:
				f = open(args[1], 'a') 
				return f

	return None

def runCommand(cmd):
	cmdOut, cmdErr, cmdRtn = mdc_popen(cmd)
	return cmdRtn, cmdOut, cmdErr 

# Normal setup for eKey in the .actimrc file
def setupEKey():
	os.system("cp ~/.actimrc ~/.actimrc.bak")
	changes = { "eKey":"testing" }
	modifyActimRC("~/.actimrc", changes, None)

def cleanupEKey():
	os.system("mv ~/.actimrc.bak ~/.actimrc")

def backUpRC(backupName, rcfile):
	rcFilename = mapRCFilename(rcfile)
	if sys.platform[:3] == 'win':
		command = 'copy'
	else:
		command = 'cp'
		
	if backupName == None:
		backupName = rcFilename + ".bak"

	cmd = "%s %s %s" % (command, rcFilename, backupName)
	os.system(cmd)

def backUpActimrc(backUpName=None):
    backUpRC(backUpName, "~/.actimrc")
    
def backUpActimdrc(backUpName=None):
    backUpRC(backUpName, "~/.actimdrc")

def restoreRC(backupName, rcfile):
    rcFilename = mapRCFilename(rcfile)
    if backupName == None:
		backupName = rcFilename + ".bak"
    if sys.platform[:3] == 'win':
		command = "copy %s %s" % (backupName, rcFilename)
		os.system(command)
		command = "del %s" % backupName
		os.system(command)
	
    else:
		os.system("mv %s %s" % (backupName, rcFilename))
    
def restoreActimrc(backupName=None):
    restoreRC(backupName, "~/.actimrc")

def restoreActimdrc(backupName=None):
    restoreRC(backupName, "~/.actimdrc")

# arg is a list of tuples. Each tuple represents name and
# value pair
def changeRC(file, arg):
	fp = open(expanduser(file), 'r')
	cf = ConfigParser()
	cf.optionxform = str
	cf.readfp(fp)
	fp.close()

	for tuple in arg:
		cf.set(None, tuple[0], tuple[1])
			
	fp = open(expanduser(file), 'w')
	cf.write(fp)
	fp.close()

def changeActimrc(arg):
	changeRC("~/.actimrc", arg)

def changeActimdrc(arg):
	changeRC("~/.actimdrc", arg)

def createRandomFile(file, size=1024):
	from random import *
	
	fp = open(file, 'w')
	x = 0
	while (x < size):
		i = randrange(0, 255, 1)
		fp.write(chr(i))
		x = x+1
	fp.close()

def createActimRCFile(optDict, file='~/.actimrc'):
	createRCFile(optDict, mapPath(file))

def createActimdRCFile(optDict, file='~/.actimdrc'):
	createRCFile(optDict, mapPath(file))

def createRCFile(optionDict, file):

	from types import *
	
	file = expanduser(file)
	fp = open(file, 'w')
	fp.write('[DEFAULT]\n')

	for x in optionDict.keys():

		if type(optionDict[x]) is StringType:
			fp.write(x + ' = ' + optionDict[x] + '\n')
		else:
			fp.write(x + ' = ' + `optionDict[x]` + '\n')
	
	fp.close()
	os.chmod(file, 0600)

# The file path format should be converted before calling
# this function
def modifyActimRC(file, defaultOptDict, securityOptDict):

	file = expanduser(file)
	if (exists(file)):
		fp = open(file, 'r')
		config = ConfigParser()
		config.optionxform = str
		config.readfp(fp)
		fp.close()

		if defaultOptDict != None:
			for name in defaultOptDict.keys():
				config.set(None, name, defaultOptDict[name])
		if securityOptDict != None:
			if not config.has_section("SECURITY"):
				config.add_section("SECURITY")
			for name in securityOptDict.keys():
				config.set("SECURITY", name, securityOptDict[name])

		fp = open(file, 'w')
		config.write(fp)
		fp.close()

# The file path format should be converted before calling
# this function
def removeRestrictedCommand(file):

	file = expanduser(file)
	if (exists(file)):
		fp = open(file, 'r')
		config = ConfigParser()
		config.optionxform = str
		config.readfp(fp)
		fp.close()

		rcmdl_pat = re.compile("^rcmdl_\w*")
		if config.has_section("SECURITY"):
			options = config.options("SECURITY")
			for opt in options:
				match = rcmdl_pat.match(opt)
				if match != None:
	   				config.remove_option("SECURITY", opt)
					
		fp = open(file, 'w')
		config.write(fp)
		fp.close()

# If cmd is defined, then run the cmd as well as with actim
# then compare the output result
# if fromFile and targetFile are defined, then check their
# existance and any content difference 
def simpleRunActim(title, clientCmd, cmd, fromFile, targetFile, eKey=None):

	stdoutMsg, stderrMsg, rtCode = mdc_popen(clientCmd)

	if mdc_isLose() and len(stdoutMsg):
		rtCode = getEventExecuteReturnCode(None, None, stdoutMsg)
		
	if rtCode != 0:
		msg = (">>>>>>>>> Fail: non zero return status, " + `rtCode` 
				+ "<<<<<<<<<<<\n") 
		msg = msg + (">>>>>>>> Fail client cmd: " + clientCmd + 
			   "<<<<<<<<<<<\n")
	else:
		msg = (">>>>>>>>> Result return successfully <<<<<<<<<<\n")

	cmdMsg = []
	if cmd:
		cmdRtn, cmdOut, cmdErr= runCommand(cmd)
		if cmdRtn: 
			cmdMsg = ["-------- Cannot double test the command: " + cmd + 	
					  "--------\n"]
			cmdMsg.append("-------- Return code: " + cmdRtn + "---------\n")
		else:
			for y in cmdOut:
				found = 0
				for x in stdoutMsg:
					if string.find(x, y) == 0:
						found = 1
						break
				if not found:
					cmdMsg.append("Fail, cannot find this line: " + y +
							  	  "------\n")
					
	diffMsg = []
	if targetFile and fromFile:
		if mdc_isLose():
			pass
		else:
			diffCmd = "diff " + fromFile + " " + targetFile

			diffOut, diffErr, diffRtn = mdc_popen(diffCmd)
			tempMsg = ("------ Both files " + fromFile + 
							", " + targetFile + " are ")
				
			if not diffRtn:
				tempMsg = tempMsg + "the SAME ------\n"
				diffMsg.append(tempMsg)
			else:
				tempMsg = tempMsg + "DIFFERENT -----\n"
				diffMsg.append(tempMsg)
		
			diffMsg.extend(diffOut)
			diffMsg.extend(diffErr)
		
			sys.stdout.writelines(diffMsg)

	return rtCode

# expectStdout and expectStderr are a list of messages
# matchMode dictates how to match against the actual
# result.
def ra_expectResult(title, clientCmd, 
					expectStdout, outMatchMode,
					expectStderr, errMatchMode, 
					expectRtn):

	stdoutMsg, stderrMsg, rtCode = mdc_popen(clientCmd)

	if mdc_isLose() and len(stdoutMsg):
		rtCode = getEventExecuteReturnCode(None, None, stdoutMsg)
		
	fp = openResultFile()

	if expectRtn != None:
		if expectRtn != rtCode:
			msg = ">>>>>>> Fail: doesn't match the expected return code <<<<<<<\n"
			msg = msg + (">>>>>> Actual return code is " + `rtCode` + "<<<<<<\n")
			msg = msg + (">>>>>> Expect return code is " + `expectRtn` + "<<<<<<\n")
			result = 1
			sys.stdout.writelines(stdoutMsg)
			sys.stdout.writelines(stderrMsg)
		else:
			msg = ">>>> Pass: actual return code matches expected return code <<<\n"
			result = 0

	if fp:
		fp.write(title)
		printStdMessages(fp, stdoutMsg, stderrMsg)
		fp.write(msg + '\n')
		fp.close()

	sys.stdout.write(title)
	printStdMessages(sys.stdout, stdoutMsg, stderrMsg)
	sys.stdout.write(msg)
	return result
	
def stopServer(port=17870):
	os.system(actimCmd() + " -C QUIT")
	if not mdc_isLose():
		a, b, c = mdc_popen("netstat | grep %s" % port)
		while (c == 0):
			a, b, c = mdc_popen("netstat | grep %s" % port)
			time.sleep(1)
	
def report(testName, passTest, fail, file="/tmp/testResults"):

	message = ("%s: Num of tests: %s. Pass: %s. Fail: %s\n\n" %
			   (testName, passTest + fail, passTest, fail))
	 
	if file == None:
		fp = sys.stdout
		fp.write(message)
	else:
		fp = open(mapPath(file), 'a')
		os.chmod(mapPath(file), 0600)
		fp.write(message)
		fp.close()

# daemon = 1 means actimd
# daemon = 0 means actim
def killActim(daemon, signal):

	if daemon:
		name = 'actimd'
	else:
		name = "'\<actim\>'"

	if sys.platform[:3] != 'win':
		a, b, c = mdc_popen("ps -elf | grep %s" % name)
        if c:
			sys.stdout.write("Can't kill server. Server not found\n")
			return 1
        else:
			list = string.split(a[0])
			pid = int(list[3])
			sys.stdout.write("Kill process id: " + `pid` + '\n')
			os.kill(pid, signal)
			return 0

